unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TeeProcs, TeEngine, Chart, ComCtrls, Series,
  Spin, Buttons, QuickRpt, QRCtrls, DbChart, QRTEE;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Chart1: TChart;
    Button1: TButton;
    Button2: TButton;
    Series1: TLineSeries;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    BLastPage: TBitBtn;
    BFirstPage: TBitBtn;
    ButtonPrevious: TBitBtn;
    ButtonNext: TBitBtn;
    QuickRep1: TQuickRep;
    QRBand1: TQRBand;
    QRImage1: TQRImage;
    CheckBox1: TCheckBox;
    TabSheet3: TTabSheet;
    QuickRep2: TQuickRep;
    QRBand2: TQRBand;
    Button3: TButton;
    QRDBChart1: TQRDBChart;
    QRChart1: TQRChart;
    Series2: TLineSeries;
    QRLabel1: TQRLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BFirstPageClick(Sender: TObject);
    procedure ButtonPreviousClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure BLastPageClick(Sender: TObject);
    procedure Chart1PageChange(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure QuickRep1BeforePrint(Sender: TCustomQuickRep;
      var PrintReport: Boolean);
    procedure QuickRep1NeedData(Sender: TObject; var MoreData: Boolean);
    procedure QuickRep1AfterPreview(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure QuickRep2NeedData(Sender: TObject; var MoreData: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure QRLabel1Print(sender: TObject; var Value: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CurrentPage : Integer;
  OrigPage : Integer;
  TotalPage : Integer;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;
  Chart1.View3D := CheckBox1.Checked;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Series1.Clear;
  Series1.FillSampleValues(SpinEdit1.Value);
  Chart1.MaxPointsPerPage := SpinEdit2.Value;
  SpinEdit3.MinValue := 1;
  SpinEdit3.MaxValue := Chart1.NumPages;
  Chart1PageChange(Chart1);
end;

procedure TForm1.BFirstPageClick(Sender: TObject);
begin
  Chart1.Page:=1;
end;

procedure TForm1.ButtonPreviousClick(Sender: TObject);
begin
  Chart1.PreviousPage;
end;

procedure TForm1.ButtonNextClick(Sender: TObject);
begin
  Chart1.NextPage;
end;

procedure TForm1.BLastPageClick(Sender: TObject);
begin
  Chart1.Page := Chart1.NumPages;
end;

procedure TForm1.Chart1PageChange(Sender: TObject);
begin
  Chart1.UndoZoom;
  SpinEdit3.Value := Chart1.Page;
  ButtonPrevious.Enabled := Chart1.Page > 1;
  ButtonNext.Enabled := Chart1.Page < Chart1.NumPages;
  BLastPage.Enabled := ButtonNext.Enabled;
  BFirstPage.Enabled := ButtonPrevious.Enabled;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  Chart1.MaxPointsPerPage := SpinEdit2.Value;
  SpinEdit3.MinValue := 1;
  SpinEdit3.MaxValue := Chart1.NumPages;
  Chart1PageChange(Chart1);
end;

procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
  Chart1.Page := TSpinEdit(Sender).Value;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  cW,cH : Integer;
begin
  cW := Chart1.Width;
  cH := Chart1.Height;
//  Chart1.Width := QRImage1.Width;
//  Chart1.Height := QRImage1.Height;
  TotalPage := Chart1.NumPages;
  QuickRep1.Preview;
  Chart1.Width := cW;
  Chart1.Height := cH;
end;

procedure TForm1.QuickRep1BeforePrint(Sender: TCustomQuickRep;
  var PrintReport: Boolean);
begin
  OrigPage := Chart1.Page;
  CurrentPage := 0;
end;

procedure TForm1.QuickRep1NeedData(Sender: TObject; var MoreData: Boolean);
var
  PIC : TBitMap;
begin
  Inc(CurrentPage);
  MoreData := (CurrentPage <= TotalPage);
  if MoreData then
    begin
      Chart1.Page := CurrentPage;
      Pic := Chart1.TeeCreateBitmap(clWhite,Chart1.ClientRect);
      try
        QRImage1.Picture.Bitmap.Assign(PIC);
      finally
        PIC.Free;
      end;
    end;
end;

procedure TForm1.QuickRep1AfterPreview(Sender: TObject);
begin
  Chart1.Page := OrigPage;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Chart1.View3D := CheckBox1.Checked;
end;

procedure TForm1.QuickRep2NeedData(Sender: TObject; var MoreData: Boolean);
begin
  Inc(CurrentPage);
  MoreData := (CurrentPage <= TotalPage);
  if MoreData then
    begin
      QRChart1.Chart.Page := CurrentPage;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I : Integer;
begin
  for i := 0 to QRChart1.Chart.SeriesCount - 1 do
    begin
      QRChart1.Chart.SeriesList.Series[I].Assign(Chart1.SeriesList.Series[I]);
    end;
  QRChart1.Chart.BottomAxis.Minimum := 0;
  QRChart1.Chart.BottomAxis.Maximum := 0;
//
    QRChart1.Chart.Title.Assign(Chart1.Title);
    QRChart1.Chart.TopAxis.Assign(Chart1.TopAxis);
    QRChart1.Chart.BottomAxis.Assign(Chart1.BottomAxis);
    QRChart1.Chart.LeftAxis.Assign(Chart1.LeftAxis);
    QRChart1.Chart.RightAxis.Assign(Chart1.RightAxis);
    QRChart1.Chart.DepthAxis.Assign(Chart1.DepthAxis);
    QRChart1.Chart.MarginTop := Chart1.MarginTop;
    QRChart1.Chart.MarginBottom := Chart1.MarginBottom;
    QRChart1.Chart.MarginLeft := Chart1.MarginLeft;
    QRChart1.Chart.MarginRight := Chart1.MarginRight;
    QRChart1.Chart.View3D := Chart1.View3D;
    QRChart1.Chart.MaxPointsPerPage := Chart1.MaxPointsPerPage;
//
  TotalPage := Chart1.NumPages;
  QuickRep2.Preview;
end;

procedure TForm1.QRLabel1Print(sender: TObject; var Value: String);
begin
  Value := 'Page : ' + FormatFloat('000',CurrentPage) + ' / ' + FormatFloat('000',TotalPage);
end;

end.
